VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4980
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   7020
   LinkTopic       =   "Form1"
   ScaleHeight     =   4980
   ScaleWidth      =   7020
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame fmSettings 
      Caption         =   "Adjust settings here, then click Go!   "
      Height          =   2415
      Left            =   120
      TabIndex        =   1
      Top             =   240
      Width           =   6735
      Begin VB.HScrollBar scrlStart 
         Height          =   255
         LargeChange     =   10
         Left            =   2400
         Max             =   100
         TabIndex        =   4
         Top             =   480
         Width           =   2535
      End
      Begin VB.HScrollBar scrlEnd 
         Height          =   255
         LargeChange     =   10
         Left            =   2400
         Max             =   100
         TabIndex        =   3
         Top             =   1080
         Value           =   100
         Width           =   2535
      End
      Begin VB.HScrollBar scrlSpeed 
         Height          =   255
         LargeChange     =   2
         Left            =   2400
         Max             =   10
         Min             =   1
         TabIndex        =   2
         Top             =   1800
         Value           =   5
         Width           =   2535
      End
      Begin VB.Label Label1 
         Alignment       =   1  'Right Justify
         Caption         =   "Starting value :"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   12
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   300
         Left            =   360
         TabIndex        =   10
         Top             =   480
         Width           =   1980
      End
      Begin VB.Label Label2 
         Alignment       =   1  'Right Justify
         Caption         =   "Ending value :"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   12
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   300
         Left            =   360
         TabIndex        =   9
         Top             =   1080
         Width           =   1980
      End
      Begin VB.Label lbStart 
         BorderStyle     =   1  'Fixed Single
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   18
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   495
         Left            =   5040
         TabIndex        =   8
         Top             =   360
         Width           =   1215
      End
      Begin VB.Label lbEnd 
         BorderStyle     =   1  'Fixed Single
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   18
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   495
         Left            =   5040
         TabIndex        =   7
         Top             =   960
         Width           =   1215
      End
      Begin VB.Label lbSpeed 
         BorderStyle     =   1  'Fixed Single
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   18
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   495
         Left            =   5040
         TabIndex        =   6
         Top             =   1680
         Width           =   1215
      End
      Begin VB.Label Label4 
         Alignment       =   1  'Right Justify
         Caption         =   "Seconds (1-10) :"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   12
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   300
         Left            =   360
         TabIndex        =   5
         Top             =   1800
         Width           =   1980
      End
   End
   Begin VB.Timer Timer1 
      Left            =   240
      Top             =   2880
   End
   Begin VB.CommandButton cmdGo 
      Caption         =   "Go!"
      Height          =   495
      Left            =   2760
      TabIndex        =   0
      Top             =   2880
      Width           =   1215
   End
   Begin VB.Shape shapLight 
      BackStyle       =   1  'Opaque
      Height          =   975
      Left            =   2880
      Shape           =   3  'Circle
      Top             =   3480
      Width           =   975
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
DefLng A-Z

Dim sngStart As Single        ' The starting value (0-100)
Dim sngEnd As Single          ' The ending value (0-100)
Dim sngSpeed As Single        ' How fast to change (0-10)

Const const_SWITCHRATE As Long = 100 ' How many times to "tick" per second.
Dim sngIncrement As Single    ' Internal - how much to change each "tick".
Const const_MINIMUM As Long = 20 ' Start/End must be at least this different.



Private Sub Form_Load()
  UpdateLabels
End Sub

Private Sub scrlStart_Change()
  UpdateLabels
End Sub

Private Sub scrlStart_Scroll()
  UpdateLabels
End Sub

Private Sub scrlEnd_Change()
  UpdateLabels
End Sub

Private Sub scrlEnd_Scroll()
  UpdateLabels
End Sub

Private Sub scrlSpeed_Change()
  UpdateLabels
End Sub

Private Sub scrlSpeed_Scroll()
  UpdateLabels
End Sub


Private Sub UpdateLabels()
  ' Set labels to display the current settings.
  lbStart = scrlStart.Value
  lbEnd = scrlEnd.Value
  lbSpeed = scrlSpeed.Value
  ' Set variables which will control the action.
  sngStart = scrlStart.Value
  sngEnd = scrlEnd.Value
  sngSpeed = scrlSpeed.Value
  
  cmdGo.Enabled = (Abs(sngStart - sngEnd) >= const_MINIMUM)
  
  SetLightTo sngStart
   
  'DoEvents
End Sub



Private Sub cmdGo_Click()
  ' This is performed when the Go! button is clicked, to start the sequence.
  sngIncrement = (sngEnd - sngStart) / sngSpeed / const_SWITCHRATE
  Timer1.Interval = 1000 / const_SWITCHRATE
  Timer1.Enabled = True
  fmSettings.Enabled = False
End Sub

Private Sub Timer1_Timer()
  ' This is fired 'n' times per second to adjust the light, once Go! clicked.
  
  ' Just modify the brightness by the appropriate amount, then
  ' check whether we've reached the ending value.
  ' The reason for the comlicated IF is that when floating point numbers
  ' are stored in binary form, they lose precision. So instead of 100, you
  ' may end up with something like 100.7878. So a straight IF X = Y test
  ' fails, and it keeps going for ever.
  sngStart = sngStart + sngIncrement
  SetLightTo sngStart
  If (sngIncrement > 0 And sngStart >= sngEnd) _
  Or (sngIncrement < 0 And sngStart <= sngEnd) Then
    Timer1.Enabled = False
    fmSettings.Enabled = True
    ReadCurrentSetting
    UpdateLabels ' To reset sngStart and so on.
    Beep
  End If
End Sub


Private Sub SetLightTo(ByVal sngNewSetting As Single)
  ' This sub sets the light to the specified brightness (0-100)
  shapLight.BackColor = RGB(sngNewSetting * 2.55, sngNewSetting * 2.55, 0)
  DoEvents
End Sub

Private Sub ReadCurrentSetting()
  ' Adjust the user settings to match the light.
  scrlStart = sngStart
End Sub
